#!/usr/bin/perl

# alarm clock
# sept 27, 2005
#
#
#
# 7/7/2011
# alarm clock 2.0 
#
# * repeat function and sounds.conf removed, alarms now happen once per minute
# instead...
# * unix commands set in wday.conf and calendar.conf
#
#
# contact:
# fusionplant.com/contact/


# modules ################################################
use strict;
#use warnings;
use IO::All;



# variables ###############################################
my $log_file = '/...path to your log.../logs/alarmclock.txt';
my $log_file_size = 3000; #log file size in lines
my $sleepDelay = 60; # cycle every n seconds, should be 60 second
my $alarm_wday_conf = '/...path to your config.../alarmclock/wday.conf';
my $alarm_calendar_conf = '/...path to your config.../alarmclock/calendar.conf';


while (1) {
    my %alarm_wday = ();
    my %alarm_calendar = ();
    my @alarm_calendar = ();
    my @alarm_wday = ();

    # check config files after n number of cycles
    @alarm_wday = io($alarm_wday_conf)->slurp;
    @alarm_calendar = io($alarm_calendar_conf)->slurp;
    

    # put list into weekday, time
    chomp @alarm_wday;
    for my $x (@alarm_wday){
	my $a = $1 if ($x =~ m/(.+? .+?) / );
	my $b = $1 if ($x =~ m/.+? .+? (.*$)/ );
	$alarm_wday{$a} = $b;
    }



    # put list into calendar of datetimes
    chomp @alarm_calendar;
    for my $x (@alarm_calendar){
	    my $a = $1 if ($x =~ m/(.+? .+?) / );
	    my $b = $1 if ($x =~ m/.+? .+? (.*$)/ );
	    $alarm_calendar{$a} = $b;
	}

    {
	# log file checker
	my @log = io($log_file)->slurp;
	my $size = @log;
	if ($size > $log_file_size){
	    my $end = $#log - $log_file_size;
	    for (0..$end){
		my $x = shift @log;
	    }
	    my $log = join '', @log;
	    $log > io($log_file);		
	}
    }
    

    my ($min, $hour, $day, $month, $year, $wday) = (localtime time())[1..6];
    $month++;
    $year += 1900;
    my $datetime = "$month/$day/$year $hour:$min";
    my $wdaytime = "$wday $hour:$min";
    # print "testing  <=> [$wdaytime], [$datetime] ...\n"; # testing, !!event!!
    if (
	$alarm_wday{$wdaytime}
	or
	$alarm_calendar{$datetime}
	){
	soundAlarm( $alarm_wday{$wdaytime} ) if $alarm_wday{$wdaytime};
	soundAlarm( $alarm_calendar{$datetime} ) if $alarm_calendar{$datetime};
	"$wdaytime $datetime" >> io($log_file);
    }

    sleep $sleepDelay;

}



########################################################################
# functions below


# here's the alarm ######################
sub soundAlarm {
# /mycommand... `/usr/bin/mpg123 $_ 1>>$log_file 2>>$log_file`;
    print `$_[0]`;
}
